/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.commands;

import eu.univento.commons.player.rank.Rank;
import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.player.CustomPlayer;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;
import java.util.stream.Collectors;

/**
 * sets ranks for players
 * @author joethei
 * @version 1.0
 */

public class SetRank extends AutoCommand<Core>{

	public SetRank(Core plugin, String command, String description, String... aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			if(p.getDatabasePlayer().isAllowed(Rank.SrBuilder)) {
				if(args.length == 2) {
					Rank rank;
                    try{
                        rank = Rank.valueOf(args[1]);
						if(Bukkit.getPlayer(args[0]) != null) {
                            CustomPlayer player = CustomPlayer.getPlayer(args[0]);
                            if(player.getDatabasePlayer().isAllowed(rank)) {
                                //p.sendMessage(p.getMessages().PREFIX() + "§cDer Spieler hat den Rang schon oder ist besser.");
                                //p.sendMessage(p.getMessages().PREFIX() + "§cÄnderungen müssen in der Datenbank stattfinden.");
                                return true;
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.Admin)) {
                                player.getDatabasePlayer().setRank(rank);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, player.getDatabasePlayer().getRank()));
                                refreshTablist();
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.SrDeveloper) && rank.equals(Rank.Developer)) {
                                player.getDatabasePlayer().setRank(Rank.Developer);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, Rank.Developer));
                                refreshTablist();
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.SrSupporter) && rank.equals(Rank.Supporter)) {
                                player.getDatabasePlayer().setRank(Rank.Supporter);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, Rank.Supporter));
                                refreshTablist();
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.SrSupporter) && rank.equals(Rank.JrSupporter)) {
                                player.getDatabasePlayer().setRank(Rank.JrSupporter);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, Rank.JrSupporter));
                                refreshTablist();
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.SrBuilder)  && rank.equals(Rank.Builder)) {
                                player.getDatabasePlayer().setRank(Rank.Builder);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, Rank.Builder));
                                refreshTablist();
                            }
                            if(p.getDatabasePlayer().isAllowed(Rank.SrBuilder)  && rank.equals(Rank.JrBuilder)) {
                                player.getDatabasePlayer().setRank(Rank.JrBuilder);
                                //p.sendMessage(p.getMessages().PREFIX() + p.getMessages().Core_SETRANK_SET(player, Rank.JrBuilder));
                                refreshTablist();
                            }
						}else {
							//p.sendMessage(p.getMessages().NOT_ONLINE(args[0]));
                        }
                    }catch(IllegalArgumentException ex) {
                        ex.printStackTrace();
                    }
                        //p.sendMessage(p.getMessages().Core_SETRANK_NO_RANK());
                    }
			}else {
				//p.sendMessage(p.getMessages().NO_PERMS());
			}
		}else {
			//sender.sendMessage(Messages.Console.NOT_A_PLAYER);
		}
		return true;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		List<String> list = Bukkit.getOnlinePlayers().stream().map(Player::getDisplayName).collect(Collectors.toList());
		for(Rank rank : Rank.values())
            list.add(rank.name());
		return list;
	}

    private void refreshTablist() {

    }

}